saver = require( "dataSaver" )

display.setStatusBar(display.HiddenStatusBar);

local pokerMachine = display.newImage("cardsBG.png",true)
pokerMachine.anchorX, pokerMachine.anchorY = 0,0
local suits = {"h","d","c","s"}; -- hearts = h,diamonds =d,clubs =c,spades=s
local deck; -- The deck of Cards
local playerHand = {} --Holds the Players Cards
local cashOutButton;
local betMaxButton; 
local betButton;
local dealButton;
local holdButtons = {} --Holds the "Hold" buttons
local isNewGame = true;
local MAXBETAMOUNT  = 15 -- Max amount player can bet
local instructionsText;
local betAmount = 0; -- How much the player has bet so far
local creditText;
local betText;
local winText;
local gamesText;
local gameData = {} -- This will hold game data -- The credits and number of games played

function setup()
    math.randomseed(os.time());
	createDeck();
	setupButtons()
	setupTextFields()
	createDataFile()
end 

function setupButtons()
    cashOutButton = display.newImage("buttonCashOut.png",89,572);
	cashOutButton.anchorX, cashOutButton.anchorY = 0,0
	local holdButtonPosition = 186
	for i=1,5 do
		local tempHoldButton = display.newImage("buttonHold1.png",holdButtonPosition + (93*(i-1)),572);
		tempHoldButton.buttonNumber = i;
		tempHoldButton.anchorX, tempHoldButton.anchorY = 0,0
		table.insert(holdButtons,tempHoldButton);
	end
	betMaxButton = display.newImage("buttonBetMax.png",679,572);
	betMaxButton.anchorX, betMaxButton.anchorY = 0,0
    betButton = display.newImage("buttonBet.png",775,572);
    betButton.anchorX, betButton.anchorY = 0,0
    dealButton  = display.newImage("buttonDeal.png",869,572);
    dealButton.anchorX, dealButton.anchorY = 0,0
    instructionsText = display.newText( "", 400,400, native.systemFont, 30)
    instructionsText:setFillColor(0,0,0)
    enableBetButtons()
end 

function setupTextFields()
	instructionsText = display.newText( "", 400,400, native.systemFont, 30)
    instructionsText:setFillColor(0,0,0)
    
    creditText = display.newText("",800,185,native.SystemFont,22)
    creditText.width =150
    creditText.align = "right"
    creditText:setFillColor(255,0,0)
    
    betText = display.newText("",800,270,native.SystemFont,22)
    betText.width =150
    betText.align = "right"
    betText:setFillColor(255,0,0)
    
    winText = display.newText("",800,355,native.SystemFont,22)
    winText.width =150
    winText.align = "right"
    winText:setFillColor(255,0,0)
    
    gamesText = display.newText("",800,440,native.SystemFont,22)
    gamesText.width =150
    gamesText.align = "right"
    gamesText:setFillColor(255,0,0)
end
function createDataFile()
gameData = saver.loadValue("gameData")
    if(gameData == nil) then
        gameData = {}
        gameData.numberOfCredits = 100
        gameData.numberOfGames = 0;
        creditText.text = "100"
        gamesText.text = "0"
        saver.saveValue("gameData",gameData)
    else
       creditText.text = gameData.numberOfCredits
       gamesText.text = gameData.numberOfGames
   end
end
function enableDealButton()
	disableDealButton()
    dealButton:addEventListener('tap',doDeal);
    instructionsText.text = " "    
end

function disableDealButton()
	dealButton:removeEventListener('tap',doDeal);
end

function enableBetButtons()
	betMaxButton:addEventListener('tap',betMax);
	betButton:addEventListener('tap',bet);
	instructionsText.text = "Place your Bet or Bet Max ($15)"
end

function disableBetButtons()
	betMaxButton:removeEventListener('tap',betMax);
	betButton:removeEventListener('tap',bet);
end

function enableHoldButtons()
	for i=1, #holdButtons do
	    holdButtons[i]:addEventListener('tap',holdCard);
    end
end

function disableHoldButtons()
	for i=1, #holdButtons do
		holdButtons[i]:removeEventListener('tap',holdCard);
	end
end

function createDeck()
	deck = {};
	for i=1, 4 do
     	for j=1, 13 do
    	    local tempCard = suits[i]..j;
    	    table.insert(deck,tempCard);
     	end
    end
    
end

function holdCard(event)
	local index = event.target.buttonNumber
	if(playerHand[index].isHolding == true) then
		playerHand[index].isHolding = false;
		playerHand[index].y = 257;
	else
	   playerHand[index].isHolding = true;
	   playerHand[index].y = 200;
	end

end

function betMax()
local gameData = saver.loadValue("gameData")
local numberOfCredits = gameData.numberOfCredits
    if(numberOfCredits >= 15) then
    enableDealButton()
	betAmount = 15;
	betText.text = betAmount;
	 instructionsText.text = " "
   doDeal()
   else
    local alert = native.showAlert( "Not Enough Credits", "You must have 15 or more Credits to Bet Max", { "OK"})
	end

end

function bet()
    enableDealButton()
	betMaxButton:removeEventListener('tap',betMax);
	 instructionsText.text = " "
   local numberOfCredits = tonumber(creditText.text - betAmount)
   print(numberOfCredits)
	 if(numberOfCredits >= 5) then
	betAmount = betAmount + 5
	betText.text = betAmount
	else
	doDeal()
	 end
	 
if(betAmount == 15) then
            doDeal()

	end
end

function doDeal()
if(isNewGame == true) then
      isNewGame = false;
	  dealInitialHand()
   else

	  dealNewCards()
	end
end

function dealInitialHand()
	disableBetButtons()
	enableHoldButtons()
	for i=1, 5 do
	     getCard(i)
	end
    local gameData = saver.loadValue("gameData")
    local currentCredits = gameData.numberOfCredits;
    local newCredits = currentCredits - betAmount;
    creditText.text = newCredits
    gameData.numberOfCredits = newCredits
    saver.saveValue("gameData",gameData)
end

function dealNewCards()
	disableDealButton()
	disableHoldButtons()
    for i = 1, 5 do
		if(playerHand[i].isHolding == false) then
			local tempCard = playerHand[i]
			tempCard:removeSelf()
			tempCard = nil
			getCard(i)
		end
		
	end
	resetCardsYPosition()
	getHand()
end

function getHand()
table.sort(playerHand, function(a,b) return a.cardNumber<b.cardNumber end)

	
	local frequencies = {}
	for i=1, 13 do
		table.insert(frequencies,0)
	end
    for i=1,#playerHand do
    frequencies[playerHand[i].cardNumber] = frequencies[playerHand[i].cardNumber]  + 1
   
    end

local numberOfPairs = 0;
local hasThreeOfAKind = false;
local hasFourOfAKind = false;
local winningHand = "Nothing"
local cashAward = 0
local isStraight = true;
local isRoyalStraight = false;
local isFlush = true;
for i=0, #frequencies do

            if(frequencies[i] == 2) then
             numberOfPairs = numberOfPairs+1;
             end
          if(frequencies[i] == 3) then
             hasThreeOfAKind = true;
          end
         if(frequencies[i] == 4) then
             hasFourOfAKind = true;
         end

end

if (numberOfPairs > 0) then
	if(numberOfPairs == 1)then
		winningHand = "1 pair"
		cashAward = 1 * betAmount
	else
	  winningHand = "2 pair"
	  cashAward =  2 * betAmount
	end
end
if
 (hasThreeOfAKind) then
	winningHand = "3 of A Kind"
	cashAward = 3 * betAmount
end

if(hasFourOfAKind)then
	winningHand = "Four of A Kind"
	cashAward = 7 * betAmount
end
if
 (numberOfPairs == 1 and hasThreeOfAKind) then
     winningHand = "Full House"
     cashAward = 6 * betAmount
end

if (playerHand[1].cardNumber == 1 and playerHand[2].cardNumber == 10 and playerHand[3].cardNumber == 11 and playerHand[4].cardNumber == 12 and playerHand[5].cardNumber == 13 )then
	 isRoyalStraight = true;
end


for  i=1, 4 do
	    if(playerHand[i].cardNumber+1 ~= playerHand[i+1].cardNumber) then
	
	 	isStraight = false
	 	break
	 end
end
for i=1, 5 do
	    if(playerHand[i].cardSuit ~= playerHand[1].cardSuit) then
	
		 isFlush = false
		 break
	end
end
if(isFlush) then
	winningHand = "Flush"
	cashAward = 5 * betAmount
end
if(isStraight) then
	winningHand = "Straight"
	cashAward = 4 * betAmount
end
if(isRoyalStraight)then
	winningHand = "Straight"
	cashAward = 4 * betAmount
end
if(isFlush and isStraight) then
	winningHand = "Straight Flush"
	cashAward = 8 * betAmount
end
if(isFlush and isRoyalStraight) then
	winningHand = "Royal Flush"
	cashAward = 9 * betAmount
end

awardWinnings(winningHand, cashAward)

end

function newGame()
	for i=1,#playerHand do
		playerHand[i]:removeSelf()
		playerHand[i] = nil
	end
	playerHand = {}
	deck = {}
	betAmount = 0
	isNewGame = true
	createDeck()
	enableBetButtons()
	instructionsText.text = "Place your Bet or Bet Max ($15)";
	winText.text = ""
	betText.text = ""
	local gameData = saver.loadValue("gameData")
	if(gameData.numberOfCredits == 0)then
		gameData.numberOfCredits = 100
		saver.saveValue("gameData",gameData)
	end
	creditText.text = gameData.numberOfCredits
	gamesText.text = gameData.numberOfGames
end

function awardWinnings(theHand, theAward)
	instructionsText.text  = "You got "..theHand
	winText.text = theAward
	local gameData = saver.loadValue("gameData")
	local currentCredits = gameData.numberOfCredits;
	local currentGames = gameData.numberOfGames;
	
	local newCredits = currentCredits + theAward
	local newGames = currentGames + 1
	
	gameData.numberOfCredits = newCredits;
	gameData.numberOfGames = newGames;
	
	saver.saveValue("gameData",gameData)

	timer.performWithDelay( 3000, newGame,1 )
end

 
function resetCardsYPosition()
	for i=1,#playerHand do
		if(playerHand[i].isHolding) then
			transition.to(playerHand[i], {time=200,y=257});
		end
	end
end

function generateCard()
	local randIndex = math.random(#deck) 
	local tempCard = display.newImage(deck[randIndex]..".png");
	tempCard.anchorX, tempCard.anchorY = 0,0
	tempCard.isHolding = false;
	tempCard.cardNumber  =  tonumber(string.sub(deck[randIndex],2,3));
	tempCard.cardSuit = string.sub(deck[randIndex],1,1)
	table.remove(deck,randIndex);
	return tempCard;
end

function getCard(cardIndex)
	local cardPosition = 199
	local tempCard = generateCard();
	playerHand[cardIndex] = tempCard;
	tempCard.x = cardPosition + (93*(cardIndex-1))
	tempCard.y = 257;
end

setup()
